# (ovitters) version 2.25.1: api 0.26; version 2.26.0: api 0.26
#global api_ver	%%(echo %%{version} | awk -F. '{print $1"."$2 + $2 % 2}')
%global api_ver 0.56
%define major	0
%define libname	%mklibname %{name} %{api_ver} %{major}
%define devname %mklibname %{name} -d

%define libdoc	%mklibname valadoc %{api_ver} %{major}
%define devdoc	%mklibname valadoc -d

%define url_ver	%(echo %{version}|cut -d. -f1,2)

# filter out bogus auto-requires
%define _requires_exceptions devel(libvalaccodegen(64bit))\\|libvalaccodegen.so()(64bit)


Summary:	Compiler for the GObject type system
Name:		vala
Version:	0.56.14
Release:	%mkrel 1
License:	LGPLv2+ and BSD
Group:		Development/Other
Url:		https://wiki.gnome.org/Vala
Source0:	https://download.gnome.org/sources/%{name}/%{url_ver}/%{name}-%{version}.tar.xz
BuildRequires:	pkgconfig(glib-2.0) >= 2.16.0
BuildRequires:	pkgconfig(gmodule-2.0) >= 2.16.0
BuildRequires:	pkgconfig(gobject-2.0) >= 2.16.0
BuildRequires:	pkgconfig(gthread-2.0) >= 2.16.0
BuildRequires:	pkgconfig(libgvc)
BuildRequires:	xsltproc
BuildRequires:	flex
BuildRequires:	bison
BuildRequires:  pkgconfig(gobject-introspection-1.0)
BuildRequires:  graphviz-devel

Requires: glibc >= 2.33

%description
Vala is a new programming language that aims to bring modern programming
language features to GNOME developers without imposing any additional
runtime requirements and without using a different ABI compared to
applications and libraries written in C.

valac, the Vala compiler, is a self-hosting compiler that translates
Vala source code into C source and header files. It uses the GObject
type system to create classes and interfaces declared in the Vala source
code. It's also planned to generate GIDL files when gobject-
introspection is ready.

The syntax of Vala is similar to C#, modified to better fit the GObject
type system. Vala supports modern language features as the following:

* Interfaces
* Properties
* Signals
* Foreach
* Lambda expressions
* Type inference for local variables
* Non-null types [PARTIAL]
* Exception handling [PLANNED]
* Assisted memory management

* type modules (aka. Plugins)

Vala is designed to allow access to existing C libraries, especially
GObject-based libraries, without the need for runtime bindings. Each
to be used library requires a Vala API file at compile-time,
containing the class and method declarations in Vala syntax. Vala
currently comes with experimental bindings for GLib and GTK+. It's
planned to provide generated bindings for the full GNOME Platform at a
later stage.

Using classes and methods written in Vala from an application written
in C is not difficult. The Vala library only has to install the
generated header files and C applications may then access the
GObject-based API of the Vala library as usual. It should also be
easily possible to write a bindings generator for access to Vala
libraries from applications written in e.g. C# as the Vala parser is written
as a library, so that all compile-time information is available when
generating a binding.

%package -n %{libname}
Group:		System/Libraries
Summary:	Vala runtime library

%description -n %{libname}
This is the runtime library of the Vala programming language.

%package -n %{devname}
Group:		Development/Other
Summary:	Vala development files
Requires:	%{libname} = %{version}-%{release}
Requires:	%{name} = %{version}-%{release}
Requires:	%{name}-tools = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}

%description -n %{devname}
Vala is a new programming language that aims to bring modern programming
language features to GNOME developers without imposing any additional
runtime requirements and without using a different ABI compared to
applications and libraries written in C.

This package contains development files for %{name}. This is not
necessary for using the %{name} compiler.

%package tools
Summary:	Tools for creating projects and bindings for %{name}
Group:		Development/Other
Requires:	%{name} = %{version}-%{release}
Requires:	gnome-common
Requires:	intltool
Requires:	libtool

%description tools
This package contains tools to generate Vala projects, as well as API bindings
from existing C libraries, allowing access from Vala programs.

%package        doc
Summary:        Documentation for %{name}
Group:		Documentation
License:        LGPLv2+

BuildArch:      noarch
Requires:       %{name} >= %{version}-%{release}

%description    doc
Vala is a new programming language that aims to bring modern programming
language features to GNOME developers without imposing any additional
runtime requirements and without using a different ABI compared to
applications and libraries written in C.

This package contains documentation in a devhelp HTML book.


%package -n     valadoc
Summary:        Vala documentation generator
Group:		Documentation
Requires:       %{name}%{?_isa} = %{version}-%{release}

%description -n valadoc
Valadoc is a documentation generator for generating API documentation from Vala
source code.


%package -n	%{libdoc}
Summary:	Shared libraries for valadoc
Group:		System/Libraries

%description -n	%{libdoc}
Valadoc is a documentation generator for generating API documentation from Vala
source code.

This package contains shared libraries for valadoc.

%package -n     %{devdoc}
Summary:        Development files for valadoc
Group:		Development/Other
Requires:       %{libdoc} = %{version}-%{release}
Requires:	valadoc = %{version}-%{release}
Obsoletes:	valadoc-devel < 0.38.1-4
Provides:	valadoc-devel = %{version}-%{release}

%description -n %{devdoc}
Valadoc is a documentation generator for generating API documentation from Vala
source code.

This package contains development libraries and header files for
developing applications that use valadoc.

%prep
%setup -q
%autopatch -p1

%build
autoreconf -vfi
%configure2_5x
%make_build

%install
rm -rf %buildroot
%make_install

find %{buildroot} -name "*.la" -delete

mkdir -p %{buildroot}%{_datadir}/vala/vapi

%files -n %{libname}
%_libdir/libvala-%{api_ver}.so.%{major}*

%files -n %{devname}
%{_libdir}/libvala-%{api_ver}.so
%{_includedir}/vala-%{api_ver}/
%{_libdir}/pkgconfig/libvala-%{api_ver}.pc
%{_libdir}/pkgconfig/vapigen-%{api_ver}.pc
%{_libdir}/pkgconfig/vapigen.pc
%{_datadir}/devhelp/books/vala-%{api_ver}
%{_datadir}/aclocal/*.m4

%files
%{_bindir}/vala
%{_bindir}/vala-%{api_ver}
%{_bindir}/valac
%{_bindir}/valac-%{api_ver}
%{_datadir}/vala-%{api_ver}
%dir %{_datadir}/vala
%dir %{_datadir}/vala/vapi
%{_datadir}/vala/vapi/*
%{_mandir}/man1/valac.1*
%{_mandir}/man1/valac-%{api_ver}.1*

%files tools
%{_bindir}/*gen*
%{_datadir}/vala/Makefile.vapigen
%{_libdir}/vala-%{api_ver}/
%{_mandir}/*/*gen*

%files doc
%doc %{_datadir}/devhelp/books/vala-%{api_ver}

%files -n valadoc
%{_bindir}/valadoc
%{_bindir}/valadoc-%{api_ver}
%{_libdir}/valadoc-%{api_ver}/
%{_datadir}/valadoc-%{api_ver}/
%{_mandir}/man1/valadoc-%{api_ver}.1*
%{_mandir}/man1/valadoc.1*

%files -n %{libdoc}
%{_libdir}/libvaladoc-%{api_ver}.so.%{major}
%{_libdir}/libvaladoc-%{api_ver}.so.%{major}.*

%files -n %{devdoc}
%{_includedir}/valadoc-%{api_ver}/
%{_libdir}/libvaladoc-%{api_ver}.so
%{_libdir}/pkgconfig/valadoc-%{api_ver}.pc


%changelog
* Fri Dec 08 2023 tex - 0.56.14-1pclos2023
- new version

* Sun Sep 04 2022 tex - 0.56.3-1pclos2022
- new version

* Fri Jul 15 2022 tex - 0.56.2-1pclos2022
- new version

* Tue Jan 11 2022 tex - 0.54.6-1pclos2022
- new version

* Tue Nov 30 2021 tex - 0.54.4-1pclos2021
- new version

